//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fuMain.h"

#define tsTAG_ANNOTATION 992233
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Chart"
#pragma link "TeEngine"
#pragma link "TeeProcs"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   Series1 = new TFastLineSeries(this);
   //CursorTool1 = new TCursorTool(NULL);
   IsPointAdded = false;
   XVal = 10.0;
   YVal = 20.0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   Chart1->AddSeries(Series1);
   ChartTool1->Series = Series1;
   //CursorTool1->FollowMouse = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Series1->FillSampleValues(20);
   IsPointAdded = true;
   //CursorTool1->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
   Series1->AddXY(XVal, YVal, "", clTeeColor);
   XVal = XVal + Random(20);
   YVal = YVal + Random(20);
   IsPointAdded = true;
   //CursorTool1->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
   Series1->AddNullXY(XVal, YVal, "");
   XVal = XVal + Random(10);
   YVal = YVal + Random(10);
   IsPointAdded = true;
   //CursorTool1->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
   bool lLegendVisible;

   Chart1->PrintMargins.Left = 5;
   Chart1->PrintMargins.Top = 5;
   Chart1->PrintMargins.Right = 5;
   Chart1->PrintMargins.Bottom = 5;

   lLegendVisible = Chart1->Legend->Visible;  // remember this so we can put it back.
   Chart1->Legend->Visible = true;

   TChartPreview *ChartPreviewer = new TChartPreview(this);

   // set the chart to be previewed
   ChartPreviewer->PreviewPanel()->Panel = this->Chart1;
   
   ChartPreviewer->ShowModal();
   
   delete ChartPreviewer;
   Chart1->Legend->Visible = lLegendVisible;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
   AnsiString labelText = "Test Label";
   int left, top;
   //MarkTool1 = new TDragMarksTool(NULL); 
   Anno1 = new TAnnotationTool(NULL);
   Anno1->Tag = tsTAG_ANNOTATION;
   Chart1 ->Tools->Add(Anno1);
   Anno1->Shape->Color = Series1->SeriesColor;
   Anno1->Shape->CustomPosition = true;

   Anno1 ->Text = labelText;
   // The YValue below is the absolute position on the whole form.
   //** top = Series1->YValue[2];

   // The CalcPos functioin gives you the relative position. More useful in our case.
   left = Series1->CalcXPos(2);
   top = Series1->CalcYPos(2);

   //The following codes show the line pointing to the point on the chart
   Anno1->Callout->XPosition = left;
   Anno1->Callout->YPosition = top;

   
   Anno1->Shape->Left = left+10;
   Anno1->Shape->Top = top+10;

   Anno1->Callout->Style = psCross;
   Anno1->Callout->Arrow->Style = psDot;
   Anno1->Callout->Arrow->Color = Series1->SeriesColor;
   Anno1->Callout->Arrow->Visible = true;
   Anno1->Callout->Visible = true;


}
//---------------------------------------------------------------------------
void __fastcall TForm1::Chart1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   int left, top;
   int lValue;

   //to update the annotation position.
   if(IsPointAdded)
   {
   left = Series1->CalcXPos(2);
   top = Series1->CalcYPos(2);

   Anno1->Callout->XPosition = left;
   Anno1->Callout->YPosition = top;

   Anno1->Shape->Left = left+10;
   Anno1->Shape->Top = top+10;




   }
   //to update the cursor position.



}
//---------------------------------------------------------------------------
